
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java 编程要点之 I/O 流详解 / iVAN</title>

    <meta name="description" content="Java 编程要点之 I/O 流详解 本文详细介绍了 Java I/O 流的基础用法和原理. 字节流(Byte Streams) 字节流处理原始的二进制数据 I/O.输入输出的是8位字节,相关的类为 InputStream 和 OutputStream. 字节流的类有许多.为了演示字节流的工作,我们将重点放在文件 I/O字节流 FileInputStream 和 FileOutputStream 上.其他种类的字节流用法类似,主要区别在于它们构造的方式,大家可以举一反三. 用法 下面一例子 CopyBytes, 从 xanadu.t">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java 编程要点之 I/O 流详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文详细介绍了 Java I/O 流的基础用法和原理。</p>
<h2>字节流(Byte Streams)</h2>
<p>字节流处理原始的二进制数据 I/O。输入输出的是8位字节，相关的类为 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/InputStream.html" rel="external nofollow noreferrer">InputStream</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/OutputStream.html" rel="external nofollow noreferrer">OutputStream</a>.</p>
<p>字节流的类有许多。为了演示字节流的工作，我们将重点放在文件 I/O字节流 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/FileInputStream.html" rel="external nofollow noreferrer">FileInputStream</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/FileOutputStream.html" rel="external nofollow noreferrer">FileOutputStream</a> 上。其他种类的字节流用法类似，主要区别在于它们构造的方式，大家可以举一反三。</p>
<h3>用法</h3>
<p>下面一例子 CopyBytes， 从 xanadu.txt 文件复制到 outagain.txt，每次只复制一个字节：</p>
<pre><code>public class CopyBytes {
 /**
 * @param args
 * @throws IOException
 */ public static void main(String[] args) throws IOException {
 FileInputStream in = null;
 FileOutputStream out = null;

 try {
 in = new FileInputStream("resources/xanadu.txt");
 out = new FileOutputStream("resources/outagain.txt");
 int c;

 while ((c = in.read()) != -1) {
 out.write(c);
 }
 } finally {
 if (in != null) {
 in.close();
 }
 if (out != null) {
 out.close();
 }
 }
 }
}
</code></pre>
<p>CopyBytes 花费其大部分时间在简单的循环里面，从输入流每次读取一个字节到输出流，如图所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3Jhdy5naXRodWJ1c2VyY29udGVudC5jb20vd2F5bGF1L2Vzc2VudGlhbC1qYXZhL21hc3Rlci9pbWFnZXMvaW8vYnl0ZVN0cmVhbS5naWY=.jpg"><br />
<h3>记得始终关闭流</h3>
<p>不再需要一个流记得要关闭它，这点很重要。所以，CopyBytes 使用 finally 块来保证即使发生错误两个流还是能被关闭。这种做法有助于避免严重的资源泄漏。</p>
<p>一个可能的错误是，CopyBytes 无法打开一个或两个文件。当发生这种情况，对应解决方案是判断该文件的流是否是其初始 null 值。这就是为什么 CopyBytes 可以确保每个流变量在调用前都包含了一个对象的引用。</p>
<h3>何时不使用字节流</h3>
<p>CopyBytes 似乎是一个正常的程序，但它实际上代表了一种低级别的 I/O，你应该避免。因为 xanadu.txt 包含字符数据时，最好的方法是使用字符流，下文会有讨论。字节流应只用于最原始的 I/O。所有其他流类型是建立在字节流之上的。</p>
<h2>字符流(Character Streams)</h2>
<p>字符流处理字符数据的 I/O，自动处理与本地字符集转化。</p>
<p>Java 平台存储字符值使用 Unicode 约定。字符流 I/O 会自动将这个内部格式与本地字符集进行转换。在西方的语言环境中，本地字符集通常是 ASCII 的8位超集。</p>
<p>对于大多数应用，字符流的 I/O 不会比 字节流 I/O操作复杂。输入和输出流的类与本地字符集进行自动转换。使用字符的程序来代替字节流可以自动适应本地字符集，并可以准备国际化，而这完全不需要程序员额外的工作。</p>
<p>如果国际化不是一个优先事项，你可以简单地使用字符流类，而不必太注意字符集问题。以后，如果国际化成为当务之急，你的程序可以方便适应这种需求的扩展。见<a href="http://docs.oracle.com/javase/tutorial/i18n/index.html" rel="external nofollow noreferrer">国际化</a>获取更多信息。</p>
<h3>用法</h3>
<p>字符流类描述在 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/Reader.html" rel="external nofollow noreferrer">Reader</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/Writer.html" rel="external nofollow noreferrer">Writer</a>。而对应文件 I/O ，在 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/FileReader.html" rel="external nofollow noreferrer">FileReader</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/FileWriter.html" rel="external nofollow noreferrer">FileWriter</a>，下面是一个 CopyCharacters 例子：</p>
<pre><code>public class CopyCharacters {
 /**
 * @param args
 * @throws IOException
 */ public static void main(String[] args) throws IOException {
 FileReader inputStream = null;
 FileWriter outputStream = null;

 try {
 inputStream = new FileReader("resources/xanadu.txt");
 outputStream = new FileWriter("resources/characteroutput.txt");

 int c;
 while ((c = inputStream.read()) != -1) {
 outputStream.write(c);
 }
 } finally {
 if (inputStream != null) {
 inputStream.close();
 }
 if (outputStream != null) {
 outputStream.close();
 }
 }
 }
}
</code></pre>
<p>CopyCharacters 与 CopyBytes 是非常相似的。最重要的区别在于 CopyCharacters 使用的 FileReader 和 FileWriter 用于输入输出，而 CopyBytes 使用 FileInputStream 和FileOutputStream 中的。请注意，这两个CopyBytes和CopyCharacters使用int变量来读取和写入；在 CopyCharacters，int 变量保存在其最后的16位字符值;在 CopyBytes，int 变量保存在其最后的8位字节的值。</p>
<h4>字符流使用字节流</h4>
<p>字符流往往是对字节流的“包装”。字符流使用字节流来执行物理I/O，同时字符流处理字符和字节之间的转换。例如，FileReader 使用 FileInputStream，而 FileWriter使用的是 FileOutputStream。</p>
<p>有两种通用的字节到字符的“桥梁”流：InputStreamReader 和 OutputStreamWriter。当没有预包装的字符流类时，使用它们来创建字符流。在 <a href="http://docs.oracle.com/javase/tutorial/networking/sockets/readingWriting.html" rel="external nofollow noreferrer">socket</a> 章节中将展示该用法。</p>
<h3>面向行的 I/O</h3>
<p>字符 I/O 通常发生在较大的单位不是单个字符。一个常用的单位是行：用行结束符结尾。行结束符可以是回车/换行序列（“<code>\r\n</code>”），一个回车（“<code>\r</code>”），或一个换行符（“<code>\n</code>”）。支持所有可能的行结束符，程序可以读取任何广泛使用的操作系统创建的文本文件。</p>
<p>修改 CopyCharacters 来演示如使用面向行的 I/O。要做到这一点，我们必须使用两个类，<a href="https://docs.oracle.com/javase/8/docs/api/java/io/BufferedReader.html" rel="external nofollow noreferrer">BufferedReader</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html" rel="external nofollow noreferrer">PrintWriter</a>的。我们会在缓冲 I/O 和Formatting 章节更加深入地研究这些类。</p>
<p>该 CopyLines 示例调用 BufferedReader.readLine 和 PrintWriter.println 同时做一行的输入和输出。</p>
<pre><code>public class CopyLines {
 /**
 * @param args
 * @throws IOException
 */ public static void main(String[] args) throws IOException {
 BufferedReader inputStream = null;
 PrintWriter outputStream = null;

 try {
 inputStream = new BufferedReader(new FileReader("resources/xanadu.txt"));
 outputStream = new PrintWriter(new FileWriter("resources/characteroutput.txt"));

 String l;
 while ((l = inputStream.readLine()) != null) {
 outputStream.println(l);
 }
 } finally {
 if (inputStream != null) {
 inputStream.close();
 }
 if (outputStream != null) {
 outputStream.close();
 }
 }
 }
}
</code></pre>
<p>调用 readLine 按行返回文本行。CopyLines 使用 println 输出带有当前操作系统的行终止符的每一行。这可能与输入文件中不是使用相同的行终止符。</p>
<p>除字符和行之外，有许多方法来构造文本的输入和输出。欲了解更多信息，请参阅 Scanning 和 Formatting。</p>
<h2>缓冲流（Buffered Streams）</h2>
<p>缓冲流通过减少调用本地 API 的次数来优化的输入和输出。</p>
<p>目前为止，大多数时候我们到看到使用非缓冲 I/O 的例子。这意味着每次读或写请求是由基础 OS 直接处理。这可以使一个程序效率低得多，因为每个这样的请求通常引发磁盘访问，网络活动，或一些其它的操作，而这些是相对昂贵的。</p>
<p>为了减少这种开销，所以 Java 平台实现缓冲 I/O 流。缓冲输入流从被称为缓冲区（buffer）的存储器区域读出数据;仅当缓冲区是空时，本地输入 API 才被调用。同样，缓冲输出流，将数据写入到缓存区，只有当缓冲区已满才调用本机输出 API。</p>
<p>程序可以转换的非缓冲流为缓冲流，这里用非缓冲流对象传递给缓冲流类的构造器。</p>
<pre><code>inputStream = new BufferedReader(new FileReader("xanadu.txt"));
outputStream = new BufferedWriter(new FileWriter("characteroutput.txt"));
</code></pre>
<p>用于包装非缓存流的缓冲流类有4个：<a href="https://docs.oracle.com/javase/8/docs/api/java/io/BufferedInputStream.html" rel="external nofollow noreferrer">BufferedInputStream</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/BufferedOutputStream.html" rel="external nofollow noreferrer">BufferedOutputStream</a> 用于创建字节缓冲字节流,<a href="https://docs.oracle.com/javase/8/docs/api/java/io/BufferedReader.html" rel="external nofollow noreferrer">BufferedReader</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/BufferedWriter.html" rel="external nofollow noreferrer">BufferedWriter</a> 用于创建字符缓冲字节流。</p>
<h3>刷新缓冲流</h3>
<p>刷新缓冲区是指在某个缓冲的关键点就可以将缓冲输出，而不必等待它填满。</p>
<p>一些缓冲输出类通过一个可选的构造函数参数支持 autoflush（自动刷新）。当自动刷新开启，某些关键事件会导致缓冲区被刷新。例如，自动刷新 PrintWriter 对象在每次调用 println 或者 format 时刷新缓冲区。查看 Formatting 了解更多关于这些的方法。</p>
<p>如果要手动刷新流，请调用其 flush 方法。flush 方法可以用于任何输出流，但对非缓冲流是没有效果的。</p>
<h2>扫描（Scanning）和格式化（Formatting）</h2>
<p>扫描和格式化允许程序读取和写入格式化的文本。</p>
<p>I/O 编程通常涉及对人类喜欢的整齐的格式化数据进行转换。为了帮助您与这些琐事，Java 平台提供了两个API。<a href="http://docs.oracle.com/javase/tutorial/essential/io/scanning.html" rel="external nofollow noreferrer">scanning</a> API 使用分隔符模式将其输入分解为标记。<a href="http://docs.oracle.com/javase/tutorial/essential/io/formatting.html" rel="external nofollow noreferrer">formatting</a> API 将数据重新组合成格式良好的，人类可读的形式。</p>
<h3>扫描</h3>
<h4>将其输入分解为标记</h4>
<p>默认情况下，Scanner 使用空格字符分隔标记。（空格字符包括空格，制表符和行终止符。为完整列表，请参阅<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Character.html#isWhitespace-char-" rel="external nofollow noreferrer">Character.isWhitespace</a>）。示例 ScanXan 读取 xanadu.txt 的单个词语并打印他们：</p>
<pre><code>public class ScanXan {
 /**
 * @param args
 * @throws IOException
 */ public static void main(String[] args) throws IOException {
 Scanner s = null;

 try {
 s = new Scanner(new BufferedReader(new FileReader("resources/xanadu.txt")));

 while (s.hasNext()) {
 System.out.println(s.next());
 }
 } finally {
 if (s != null) {
 s.close();
 }
 }
 }
}
</code></pre>
<p>虽然 Scanner 不是流，但你仍然需要关闭它，以表明你与它的底层流执行完成。</p>
<p>调用 useDelimiter() ,指定一个正则表达式可以使用不同的标记分隔符。例如,假设您想要标记分隔符是一个逗号，后面可以跟空格。你会调用</p>
<pre><code>s.useDelimiter(",\\s*");
</code></pre>
<h4>转换成独立标记</h4>
<p>该 ScanXan 示例是将所有的输入标记为简单的字符串值。Scanner 还支持所有的 Java 语言的基本类型（除 char），以及 BigInteger 和 BigDecimal 的。此外，数字值可以使用千位分隔符。因此，在一个美国的区域设置，Scanner 能正确地读出字符串“32,767”作为一个整数值。</p>
<p>这里要注意的是语言环境，因为千位分隔符和小数点符号是特定于语言环境。所以，下面的例子将无法正常在所有的语言环境中，如果我们没有指定 scanner 应该用在美国地区工作。可能你平时并不用关心，因为你输入的数据通常来自使用相同的语言环境。可以使用下面的语句来设置语言环境：</p>
<pre><code>s.useLocale(Locale.US);
</code></pre>
<p>该 ScanSum 示例是将读取的 double 值列表进行相加：</p>
<pre><code>public class ScanSum {
 /**
 * @param args
 * @throws IOException
 */ public static void main(String[] args) throws IOException {
 Scanner s = null;
 double sum = 0;

 try {
 s = new Scanner(new BufferedReader(new FileReader("resources/usnumbers.txt")));
 s.useLocale(Locale.US);

 while (s.hasNext()) {
 if (s.hasNextDouble()) {
 sum += s.nextDouble();
 } else {
 s.next();
 }
 }
 } finally {
 s.close();
 }

 System.out.println(sum);
 }
}
</code></pre>
<p>输出为:1032778.74159</p>
<h3>格式化</h3>
<p>实现格式化流对象要么是 字符流类的 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html" rel="external nofollow noreferrer">PrintWriter</a> 的实例，或为字节流类的 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintStream.html" rel="external nofollow noreferrer">PrintStream</a> 的实例。</p>
<p><em>注：对于 PrintStream 对象，你很可能只需要 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/System.html#out" rel="external nofollow noreferrer">System.out</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/System.html#err" rel="external nofollow noreferrer">System.err</a>。 （请参阅命令行I/O）当你需要创建一个格式化的输出流，请实例化 PrintWriter，而不是 PrintStream。</em></p>
<p>像所有的字节和字符流对象一样，PrintStream 和 PrintWriter 的实例实现了一套标准的 write 方法用于简单的字节和字符输出。此外，PrintStream 和 PrintWriter 的执行同一套方法，将内部数据转换成格式化输出。提供了两个级别的格式： * print 和 println 在一个标准的方式里面格式化独立的值 。 * format 用于格式化几乎任何数量的格式字符串值，且具有多种精确选择。</p>
<h4>print 和 println 方法</h4>
<p>调用 print 或 println 输出使用适当 toString 方法变换后的值的单一值。我们可以看到这 Root 例子：</p>
<pre><code>public class Root {
 /**
 * @param args
 */ public static void main(String[] args) {
 int i = 2;
 double r = Math.sqrt(i);

 System.out.print("The square root of ");
 System.out.print(i);
 System.out.print(" is ");
 System.out.print(r);
 System.out.println(".");

 i = 5;
 r = Math.sqrt(i);
 System.out.println("The square root of " + i + " is " + r + ".");
 }
}
</code></pre>
<p>输出为：</p>
<pre><code>The square root of 2 is 1.4142135623730951.
The square root of 5 is 2.23606797749979.
</code></pre>
<p>在 i 和 r 变量格式化了两次：第一次在重载的 print 使用代码，第二次是由Java编译器转换码自动生成，它也利用了 toString。您可以用这种方式格式化任意值，但对于结果没有太多的控制权。</p>
<h4>format 方法</h4>
<p>该 format 方法用于格式化基于 format string（格式字符串） 多参。格式字符串包含嵌入了 format specifiers （格式说明)的静态文本;除非使用了格式说明，否则格式字符串输出不变。</p>
<p>格式字符串支持许多功能。在本教程中，我们只介绍一些基础知识。有关完整说明，请参阅 API 规范关于<a href="https://docs.oracle.com/javase/8/docs/api/java/util/Formatter.html#syntax" rel="external nofollow noreferrer">格式字符串语法</a>。</p>
<p>Root2 示例在一个 format 调用里面设置两个值：</p>
<pre><code>public class Root2 {
 /**
 * @param args
 */ public static void main(String[] args) {
 int i = 2;
 double r = Math.sqrt(i);

 System.out.format("The square root of %d is %f.%n", i, r);
 }
}
</code></pre>
<p>输出为：The square root of 2 is 1.414214.</p>
<p>像本例中所使用的格式为：</p>
<ul>
<li>d 格式化整数值为小数</li>
<li>f 格式化浮点值作为小数</li>
<li>n 输出特定于平台的行终止符。</li>
</ul>
<p>这里有一些其他的转换格式：</p>
<ul>
<li>x 格式化整数为十六进制值</li>
<li>s 格式化任何值作为字符串</li>
<li>tB 格式化整数作为一个语言环境特定的月份名称。</li>
</ul>
<p>还有许多其他的转换。</p>
<p><em>注意：除了 <code>%%</code> 和 <code>%n</code>，其他格式符都要匹配参数，否则抛出异常。在 Java 编程语言中，<code>\ n</code>转义总是产生换行符（<code>\u000A</code>）。不要使用<code>\ñ</code>除非你特别想要一个换行符。为了针对本地平台得到正确的行分隔符，请使用<code>％n</code>。</em></p>
<p>除了用于转换，格式说明符可以包含若干附加的元素，进一步定制格式化输出。下面是一个 Format 例子，使用一切可能的一种元素。</p>
<pre><code>public class Format {
 /**
 * @param args
 */ public static void main(String[] args) {
 System.out.format("%f, %1$+020.10f %n", Math.PI);
 }
}
</code></pre>
<p>输出为：3.141593, +00000003.1415926536</p>
<p>附加元素都是可选的。下图显示了长格式符是如何分解成元素</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3Jhdy5naXRodWJ1c2VyY29udGVudC5jb20vd2F5bGF1L2Vzc2VudGlhbC1qYXZhL21hc3Rlci9pbWFnZXMvaW8vaW8tc3BlYy5naWY=.jpg"><br />元件必须出现在显示的顺序。从合适的工作，可选的元素是：</p>
<ul>
<li>Precision(精确)。对于浮点值，这是格式化值的数学精度。对于 s 和其他一般的转换，这是格式化值的最大宽度;该值右截断，如果有必要的。</li>
<li>Width(宽度)。格式化值的最小宽度;如有必要，该值被填充。默认值是左用空格填充。</li>
<li>Flags(标志)指定附加格式设置选项。在 Format 示例中，+ 标志指定的数量应始终标志格式，以及0标志指定0是填充字符。其他的标志包括 - （垫右侧）和（与区域特定的千位分隔符格式号）。请注意，某些标志不能与某些其他标志或与某些转换使用。</li>
<li>Argument Index(参数索引)允许您指定的参数明确匹配。您还可以指定&lt;到相同的参数作为前面的说明一致。这样的例子可以说：<code>System.out.format（“％F，％&lt;+ 020.10f％N”，Math.PI）;</code></li>
</ul>
<h2>命令行 I/O</h2>
<p>命令行 I/O 描述了标准流（Standard Streams）和控制台（Console）对象。</p>
<p>Java 支持两种交互方式：标准流（Standard Streams）和通过控制台（Console）。</p>
<h3>标准流</h3>
<p>标准流是许多操作系统的一项功能。默认情况下，他们从键盘读取输入和写出到显示器。它们还支持对文件和程序之间的 I/O，但该功能是通过命令行解释器，而不是由程序控制。</p>
<p>Java平台支持三种标准流：标准输入（Standard Input, 通过 System.in 访问）、标准输出（Standard Output, 通过System.out 的访问）和标准错误（ Standard Error, 通过System.err的访问）。这些对象被自动定义，并不需要被打开。标准输出和标准错误都用于输出;错误输出允许用户转移经常性的输出到一个文件中，仍然能够读取错误消息。</p>
<p>您可能希望标准流是字符流，但是，由于历史的原因，他们是字节流。 System.out 和System.err 定义为 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintStream.html" rel="external nofollow noreferrer">PrintStream</a> 的对象。虽然这在技术上是一个字节流，PrintStream 利用内部字符流对象来模拟多种字符流的功能。</p>
<p>相比之下，System.in 是一个没有字符流功能的字节流。若要想将标准的输入作为字符流，可以包装 System.in 在 InputStreamReader</p>
<pre><code>InputStreamReader cin = new InputStreamReader(System.in);
</code></pre>
<h3>Console (控制台)</h3>
<p>更先进的替代标准流的是 Console 。这个单一，预定义的 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/Console.html" rel="external nofollow noreferrer">Console</a> 类型的对象，有大部分的标准流提供的功能，另外还有其他功能。Console 对于安全的密码输入特别有用。Console 对象还提供了真正的输入输出字符流，是通过 reader 和 writer 方法实现的。</p>
<p>若程序想使用 Console ，它必须尝试通过调用 System.console() 检索 Console 对象。如果 Console 对象存在，通过此方法将其返回。如果返回 NULL，则 Console 操作是不允许的，要么是因为操作系统不支持他们或者是因为程序本身是在非交互环境中启动的。</p>
<p>Console 对象支持通过读取密码的方法安全输入密码。该方法有助于在两个方面的安全。第一，它抑制回应，因此密码在用户的屏幕是不可见的。第二，readPassword 返回一个字符数组，而不是字符串，所以，密码可以被覆盖，只要它是不再需要就可以从存储器中删除。</p>
<p>Password 例子是一个展示了更改用户的密码原型程序。它演示了几种 Console 方法</p>
<pre><code>public class Password {
 /**
 * @param args
 */ public static void main(String[] args) {
 Console c = System.console();
 if (c == null) {
 System.err.println("No console.");
 System.exit(1);
 }

 String login = c.readLine("Enter your login: ");
 char [] oldPassword = c.readPassword("Enter your old password: ");

 if (verify(login, oldPassword)) {
 boolean noMatch;
 do {
 char [] newPassword1 = c.readPassword("Enter your new password: ");
 char [] newPassword2 = c.readPassword("Enter new password again: ");
 noMatch = ! Arrays.equals(newPassword1, newPassword2);
 if (noMatch) {
 c.format("Passwords don't match. Try again.%n");
 } else {
 change(login, newPassword1);
 c.format("Password for %s changed.%n", login);
 }
 Arrays.fill(newPassword1, ' ');
 Arrays.fill(newPassword2, ' ');
 } while (noMatch);
 }

 Arrays.fill(oldPassword, ' ');
 }

 // Dummy change method. static boolean verify(String login, char[] password) {
 // This method always returns // true in this example. // Modify this method to verify // password according to your rules. return true;
 }

 // Dummy change method. static void change(String login, char[] password) {
 // Modify this method to change // password according to your rules.
 }
}
</code></pre>
<p>上面的流程是：</p>
<ul>
<li>尝试检索 Console 对象。如果对象是不可用，中止。</li>
<li>调用 Console.readLine 提示并读取用户的登录名。</li>
<li>调用 Console.readPassword 提示并读取用户的现有密码。</li>
<li>调用 verify 确认该用户被授权可以改变密码。（在本例中，假设 verify 是总是返回true ）</li>
<li>重复下列步骤，直到用户输入的密码相同两次：
<ul>
<li>调用 Console.readPassword 两次提示和读一个新的密码。</li>
<li>如果用户输入的密码两次，调用 change 去改变它。 （同样，change 是一个虚拟的方法）</li>
<li>用空格覆盖这两个密码。</li>
</ul>
</li>
<li>用空格覆盖旧的密码。</li>
</ul>
<h2>数据流（Data Streams）</h2>
<p>Data Streams 处理原始数据类型和字符串值的二进制 I/O。</p>
<p>支持基本数据类型的值（(boolean, char, byte, short, int, long, float, 和 double）以及字符串值的二进制 I/O。所有数据流实现 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/DataInput.html" rel="external nofollow noreferrer">DataInput</a> 或 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/DataOutput.html" rel="external nofollow noreferrer">DataOutput</a> 接口。本节重点介绍这些接口的广泛使用的实现，<a href="https://docs.oracle.com/javase/8/docs/api/java/io/DataInputStream.html" rel="external nofollow noreferrer">DataInputStream</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/DataOutputStream.html" rel="external nofollow noreferrer">DataOutputStream</a>类。</p>
<p>DataStreams 例子展示了数据流通过写出的一组数据记录到文件，然后再次从文件中读取这些记录。每个记录包括涉及在发票上的项目，如下表中三个值：</p>
<table>
<thead>
<tr>
<th>记录中顺序</th>
<th>数据类型</th>
<th>数据描述</th>
<th>输出方法</th>
<th>输入方法</th>
<th>示例值</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td>double</td>
<td>Item price</td>
<td>DataOutputStream.writeDouble</td>
<td>DataInputStream.readDouble</td>
<td>19.99</td>
</tr>
<tr>
<td>2</td>
<td>int</td>
<td>Unit count</td>
<td>DataOutputStream.writeInt</td>
<td>DataInputStream.readInt</td>
<td>12</td>
</tr>
<tr>
<td>3</td>
<td>String</td>
<td>Item description</td>
<td>DataOutputStream.writeUTF</td>
<td>DataInputStream.readUTF</td>
<td>"Java T-Shirt"</td>
</tr>
</tbody>
</table>
<p>首先，定义了几个常量，数据文件的名称，以及数据。</p>
<pre><code>static final String dataFile = "invoicedata";

static final double[] prices = { 19.99, 9.99, 15.99, 3.99, 4.99 };
static final int[] units = { 12, 8, 13, 29, 50 };
static final String[] descs = {
 "Java T-shirt",
 "Java Mug",
 "Duke Juggling Dolls",
 "Java Pin",
 "Java Key Chain"
};
</code></pre>
<p>DataStreams 打开一个输出流，提供一个缓冲的文件输出字节流：</p>
<pre><code>out = new DataOutputStream(new BufferedOutputStream(
 new FileOutputStream(dataFile)))
</code></pre>
<p>DataStreams 写出记录并关闭输出流：</p>
<pre><code>for (int i = 0; i &lt; prices.length; i ++) {
 out.writeDouble(prices[i]);
 out.writeInt(units[i]);
 out.writeUTF(descs[i]);
}
</code></pre>
<p>该 writeUTF 方法写出以 UTF-8 改进形式的字符串值。</p>
<p>现在，DataStreams 读回数据。首先，它必须提供一个输入流，和变量来保存的输入数据。像 DataOutputStream 、DataInputStream 类，必须构造成一个字节流的包装器。</p>
<pre><code>in = new DataInputStream(new
 BufferedInputStream(new FileInputStream(dataFile)));

double price;
int unit;
String desc;
double total = 0.0;
</code></pre>
<p>现在，DataStreams 可以读取流里面的每个记录，并在遇到它时将数据报告出来：</p>
<pre><code>try {
 while (true) {
 price = in.readDouble();
 unit = in.readInt();
 desc = in.readUTF();
 System.out.format("You ordered %d" + " units of %s at $%.2f%n",
 unit, desc, price);
 total += unit * price;
 }
} catch (EOFException e) {
}
</code></pre>
<p>请注意，DataStreams 通过捕获 EOFException 检测文件结束的条件而不是测试无效的返回值。所有实现了 DataInput 的方法都使用 EOFException 类来代替返回值。</p>
<p>还要注意的是 DataStreams 中的各个 write 需要匹配对应相应的 read。它需要由程序员来保证。</p>
<p>DataStreams 使用了一个非常糟糕的编程技术：它使用浮点数来表示的货币价值。在一般情况下，浮点数是不好的精确数值。这对小数尤其糟糕，因为共同值（如 0.1），没有一个二进制的表示。</p>
<p>正确的类型用于货币值是 <a href="https://docs.oracle.com/javase/8/docs/api/java/math/BigDecimal.html" rel="external nofollow noreferrer">java.math.BigDecimal</a> 的。不幸的是，BigDecimal 是一个对象的类型，因此它不能与数据流工作。然而，BigDecimal 将与对象流工作，而这部分内容将在下一节讲解。</p>
<h2>对象流（Object Streams）</h2>
<p>对象流处理对象的二进制 I/O。</p>
<p>正如数据流支持的是基本数据类型的 I/O，对象流支持的对象 I/O。大多数，但不是全部，标准类支持他们的对象的序列化，都需要实现 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/Serializable.html" rel="external nofollow noreferrer">Serializable</a> 接口。</p>
<p>对象流类包括 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/ObjectInputStream.html" rel="external nofollow noreferrer">ObjectInputStream</a> 和 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/ObjectOutputStream.html" rel="external nofollow noreferrer">ObjectOutputStream</a> 的。这些类实现的 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/ObjectInput.html" rel="external nofollow noreferrer">ObjectInput</a> 与 <a href="https://docs.oracle.com/javase/8/docs/api/java/io/ObjectOutput.html" rel="external nofollow noreferrer">ObjectOutput</a> 的，这些都是 DataInput 和DataOutput 的子接口。这意味着，所有包含在数据流中的基本数据类型 I/O 方法也在对象流中实现了。这样一个对象流可以包含基本数据类型值和对象值的混合。该ObjectStreams 例子说明了这一点。ObjectStreams 创建与 DataStreams 相同的应用程序。首先，价格现在是 <a href="https://docs.oracle.com/javase/8/docs/api/java/math/BigDecimal.html" rel="external nofollow noreferrer">BigDecimal</a> 对象，以更好地代表分数值。其次，<a href="https://docs.oracle.com/javase/8/docs/api/java/util/Calendar.html" rel="external nofollow noreferrer">Calendar</a> 对象被写入到数据文件中，指示发票日期。</p>
<pre><code>public class ObjectStreams {
 static final String dataFile = "invoicedata";

 static final BigDecimal[] prices = {
 new BigDecimal("19.99"),
 new BigDecimal("9.99"),
 new BigDecimal("15.99"),
 new BigDecimal("3.99"),
 new BigDecimal("4.99") };
 static final int[] units = { 12, 8, 13, 29, 50 };
 static final String[] descs = { "Java T-shirt",
 "Java Mug",
 "Duke Juggling Dolls",
 "Java Pin",
 "Java Key Chain" };

 public static void main(String[] args) throws IOException, ClassNotFoundException {

 ObjectOutputStream out = null;
 try {
 out = new ObjectOutputStream(new
 BufferedOutputStream(new FileOutputStream(dataFile)));

 out.writeObject(Calendar.getInstance());
 for (int i = 0; i &lt; prices.length; i ++) {
 out.writeObject(prices[i]);
 out.writeInt(units[i]);
 out.writeUTF(descs[i]);
 }
 } finally {
 out.close();
 }

 ObjectInputStream in = null;
 try {
 in = new ObjectInputStream(new
 BufferedInputStream(new FileInputStream(dataFile)));

 Calendar date = null;
 BigDecimal price;
 int unit;
 String desc;
 BigDecimal total = new BigDecimal(0);

 date = (Calendar) in.readObject();

 System.out.format ("On %tA, %&lt;tB %&lt;te, %&lt;tY:%n", date);

 try {
 while (true) {
 price = (BigDecimal) in.readObject();
 unit = in.readInt();
 desc = in.readUTF();
 System.out.format("You ordered %d units of %s at $%.2f%n",
 unit, desc, price);
 total = total.add(price.multiply(new BigDecimal(unit)));
 }
 } catch (EOFException e) {}
 System.out.format("For a TOTAL of: $%.2f%n", total);
 } finally {
 in.close();
 }
 }
}
</code></pre>
<p>如果的 readObject() 不返回预期的对象类型，试图将它转换为正确的类型可能会抛出一个 <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/ClassNotFoundException.html" rel="external nofollow noreferrer">ClassNotFoundException</a>。在这个简单的例子，这是不可能发生的，所以我们不要试图捕获异常。相反，我们通知编译器，我们已经意识到这个问题，添加 ClassNotFoundException 到主方法的 throws 子句中的。</p>
<h3>复杂对象的 I/O</h3>
<p>writeObject 和 readObject 方法简单易用，但它们包含了一些非常复杂的对象管理逻辑。这不像 Calendar 类，它只是封装了原始值。但许多对象包含其他对象的引用。如果 readObject 从流重构一个对象，它必须能够重建所有的原始对象所引用的对象。这些额外的对象可能有他们自己的引用，依此类推。在这种情况下，writeObject 遍历对象引用的整个网络，并将该网络中的所有对象写入流。因此，writeObject 单个调用可以导致大量的对象被写入流。</p>
<p>如下图所示，其中 writeObject 调用名为 a 的单个对象。这个对象包含对象的引用 b和 c，而 b 包含引用 d 和 e。调用 writeObject(a) 写入的不只是一个 a，还包括所有需要重新构成的这个网络中的其他4个对象。当通过 readObject 读回 a 时，其他四个对象也被读回，同时，所有的原始对象的引用被保留。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3Jhdy5naXRodWJ1c2VyY29udGVudC5jb20vd2F5bGF1L2Vzc2VudGlhbC1qYXZhL21hc3Rlci9pbWFnZXMvaW8vaW8tdHJhdi5naWY=.jpg"><br />如果在同一个流的两个对象引用了同一个对象会发生什么？流只包含一个对象的一个拷贝，尽管它可以包含任何数量的对它的引用。因此，如果你明确地写一个对象到流两次，实际上只是写入了2此引用。例如，如果下面的代码写入一个对象 ob 两次到流：</p>
<pre><code>Object ob = new Object();
out.writeObject(ob);
out.writeObject(ob);
</code></pre>
<p>每个 writeObject 都对应一个 readObject， 所以从流里面读回的代码如下：</p>
<pre><code>Object ob1 = in.readObject();
Object ob2 = in.readObject();
</code></pre>
<p>ob1 和 ob2 都是相同对象的引用。</p>
<p>然而，如果一个单独的对象被写入到两个不同的数据流，它被有效地复用 - 一个程序从两个流读回的将是两个不同的对象。</p>
<h2>源码</h2>
<p>本章例子的源码，可以在 <a href="https://github.com/waylau/essential-java" rel="external nofollow noreferrer">https://github.com/waylau/essential-java</a> 中 <code>com.waylau.essentialjava.io</code> 包下找到。</p>
<h2>参考</h2>
<ul>
<li>更多内容可移步至笔者所著开源书<a href="https://github.com/waylau/essential-java" rel="external nofollow noreferrer">《Java 编程要点》</a></li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:16:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java 编程要点之 I/O 流详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJZXr4z.html" rel="bookmark">Java 编程要点之并发（Concurrency）详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文详细介绍了 Java 并发(Concurrency)的基础用法和原理. 计算机用户想当然地认为他们的系统在一个时间可以做多件事.他们认为,他们可以工作在一个字处理器,而其他应用程序在下载文件,管理打印队列和音频流.即使是单一的应用程序通常也是被期望在一个时间来做多件事.例如,音频流应用程序必须同时读取数字音频,解压,管理播放,并更新显示.即使字处理器应该随时准备响应键盘和鼠标事件,不管多么繁忙,它总是能格式化文本或更新显示.可以做这样的事情的软件称为并发软件(concurrent softw			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvmy9Nb.html" rel="bookmark">Java开发中的23种设计模式详解&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java开发中的23种设计模式详解(转) 设计模式(Design Patterns)                                   --可复用面向对象软件的基础 设计模式(Design pattern)是一套被反复使用.多数人知晓的.经过分类编目的.代码设计经验的总结.使用设计模式是为了可重用代码.让代码更容易被他人理解.保证代码可靠性. 毫无疑问,设计模式于己于他人于系统都是多赢的,设计模式使代码编制真正工程化,设计模式是软件工程的基石,如同大厦的一块块砖石一样.项目中合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKoE1p.html" rel="bookmark">Node&period;js编程中客户端Session的使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Node.js编程中客户端Session的使用详解,是Node.js入门学习中的基础知识,需要的朋友可以参考下 静态网站很容易扩展.你只需要全部缓存,不需要考虑从不同服务器组合有状态的内容给用户. 可惜,大多数Web应用使用有状态的内容提供个性化体验.如果你的应用可以登录,就需要记住用户的Session.经典的处理方法是客户端设置包含随机唯一Session标识的Cookie,被标识的Session数据保存到服务端. 扩展有状态服务 当扩展服务的时候,你肯定有三种选择: 不同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QJWnp.html" rel="bookmark">iOS网络编程之四&mdash;&mdash;请求类NSURLRequest使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS网络编程之四--请求类NSURLRequest使用详解 一.引言         在前面几篇博客中,介绍了iOS开发中的网络编程相关内容并且介绍了常用了两个平行的网络框架NSURLSession和NSURLConnection.无论是NSURLSession类还是NSURLConnection类,其网络请求都是通过NSURLRequest类进行发起的,本篇博客将介绍NSURLRequest类的用法和其中请求属性的设置.         前几篇博客地址如下: 1.iOS网络框架介绍:http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV7DoYb.html" rel="bookmark">Java的JSON处理器fastjson使用方法详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				fastjson 是一个性能很好的 Java 语言实现的 JSON 解析器和生成器,来自阿里巴巴的工程师开发. 主要特点: • 快速FAST (比其它任何基于Java的解析器和生成器更快,包括jackson) • 强大(支持普通JDK类包括任意Java Bean Class.Collection.Map.Date或enum) • 零依赖(没有依赖其它任何类库除了JDK) 示例代码: import com.alibaba.fastjson.JSON; Group group = new Group			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZkE3z.html" rel="bookmark">Java多线程原理及ThreadLocal多线程实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.线程和进程的概念 现在的操作系统是多任务操作系统.多线程是实现多任务的一种方式. 进程是程序的一个动态执行过程,是指一个内存中运行的应用程序,每个进程都有自己独立的一块内存空间,一个进程中可以启动多个线程.比如在 Windows系统中,一个运行的exe就是一个进程.线程是指进程中的一个执行流程,一个进程中可以运行多个线程.比如java.exe进程中可以运行很多线程.线程总是属于某个进程,进程中的多个线程共享进程的内存.&quot;同时&quot;执行是人的感觉,在线程之间实际上轮换执行. 二.Java			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYN4DQp.html" rel="bookmark">java中哈希表及其应用详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				哈希表也称为散列表,是用来存储群体对象的集合类结构. 什么是哈希表 数组和向量都可以存储对象,但对象的存储位置是随机的,也就是说对象本身与其存储位置之间没有必然的联系.当要查找一个对象时,只能以某种顺序(如顺序查找或二分查找)与各个元素进行比较,当数组或向量中的元素数量很多时,查找的效率会明显的降低. 一种有效的存储方式,是不与其他元素进行比较,一次存取便能得到所需要的记录.这就需要在对象的存储位置和对象的关键属性(设为 k)之间建立一个特定的对应关系(设为 f),使每个对象与一个唯一的存储位置			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1OYob.html" rel="bookmark">Java太阳系小游戏分析和源码详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近看了面向对象的一些知识,然后跟着老师的讲解做了一个太阳系各行星绕太阳转的小游戏,来练习巩固一下最近学的知识: 用到知识点:类的继承.方法的重载与重写.多态.封装等 分析: 1.需要加载图片.画图 2.建一个面板,主页面 3.行星类 效果图: 先看一下源码结构图: 现在逐步分析各个类的功能: 1)工具类-----util包中     --Constant类   封装了游戏中用到的常量     --GameUtil类  封装了游戏的图片加载功能     --MyFrame类  封装了游戏面板的构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWxjVEp.html" rel="bookmark">JAVA中static方法的用法实例详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JAVA中static方法的用法.分享给大家供大家参考,具体如下: static表示&quot;全局&quot;或者&quot;静态&quot;的意思,用来修饰成员变量和成员方法,也可以形成静态static代码块,但是Java语言中没有全局变量的概念. 被static修饰的成员变量和成员方法独立于该类的任何对象.也就是说,它不依赖类特定的实例,被类的所有实例共享.只要这个类被加载,Java虚拟机就能根据类名在运行时数据区或者方法区内找到他们.因此,static对象可以在它的任何对象创建之前访			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE486z.html" rel="bookmark" class="title">源码-求一款叫openlaszlo的软件 资源库只找到一半的下载</a>
					<div>
						问题描述 求一款叫openlaszlo的软件 资源库只找到一半的下载 谁有openlazlo的网盘下载地址么 网上找不到下载 顺便求openmeeting1.6的客户端源码 解决方案 http://w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAAW2M.html" rel="bookmark" class="title">站长必备的七大不一样的伪原创素材来源</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 最近百度收录大波动.很多站长收录一夜之间从上千掉的几十,站长们日夜辛辛苦苦的更新文章就换来如此结果?很多站长变得愤怒,狂躁!但站长朋友们有没有仔细想想自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLgO0M.html" rel="bookmark" class="title">HTML5权威指南--标签新变化&comma;文件API&comma;拖放API&lpar;简要学习笔记一&rpar;</a>
					<div>
						1.标签元素更加语义化   2.内容类型仍然为&quot;text/html&quot;    扩展符仍然为html或者htm.    &lt;1&gt;DOCTYPE 声明&lt;!DOCTYPE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBY3Kz.html" rel="bookmark" class="title">HTML表格进阶&lpar;TABLE ADVANCED&rpar;</a>
					<div>
						表格的色彩 &lt;------Background Color &amp; Image-------&gt; 表元的背景色彩和背景图象&lt;th bgcolor=#&gt; &lt;th back ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAeV3M.html" rel="bookmark" class="title">GridViewRow可以任意位置单击引发事件的方法</a>
					<div>
						GridView 是 ASP.NET 2.0 中应用最为广泛一个控件,几乎所有的数据操作都需要它,正如我们平常所应用的,可以编辑.删除.选择等等,但如果客户有需要通过单击行而引发超链接或者进入行编辑状 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqvG3p.html" rel="bookmark" class="title">SEOVIP被降权百度说误伤，谁向草根说误伤</a>
					<div>
						SEOVIP现在是大家都知道的一个SEO界知名网站,原因是这个网站&quot;天生富贵&quot;,背后站着高人和名人--SEO界大名鼎鼎的柳焕斌.所以这个网站在短短的时间内就可以把SEO培训这个词做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zO7Amz.html" rel="bookmark" class="title">&period;Net&sol;C&num;&colon; 实现支持断点续传多线程下载的 Http Web 客户端工具类 &lpar;C&num; DIY HttpWebClient&rpar;</a>
					<div>
						client|web|多线程|客户端|下载 /* .Net/C#: 实现支持断点续传多线程下载的 Http Web 客户端工具类 (C# DIY HttpWebClient) * Reflector  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8n2xb.html" rel="bookmark" class="title">浅谈对Alexa网站排名的看法</a>
					<div>
						首先说一个Alexa,Alexa是一家统计全球网站流量并给出全球排名等数据的网站,它的工作原理是,当上网者通过安装有Alexa工具条的浏览器去访问一个网站时,Alexa工具条就会把上网者的访问信息记录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7vorp.html" rel="bookmark" class="title">一个简单而重要的SEO公式</a>
					<div>
						SEO是的范围很广,包含的因素也是非常多的,真要把它用一个公式来表达出来,还真是没那么容易,前几天在网上随便浏览SEO类的文章,无意间发现了一篇文章,它讲的内容就是一个简化了的SEO优化公式,虽然这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yGxQz.html" rel="bookmark" class="title">PS输入的字母显示的都是大写怎么办&quest;</a>
					<div>
						  PS输入的字母显示的都是大写怎么办?          1.首先,打开PS,新建空白文档,输入一些英文字母,如下图,字母都是大写. 2.首先,看一下大写键是否打开,很多不熟悉电脑的长辈可能不太了解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxk3Ab.html" rel="bookmark" class="title">php检查是否是ajax请求的方法</a>
					<div>
						 通过这段代码可以判断用户的请求是否来自AJAX XMLHttpRequest,以区别普通post,get和ajax   1 2 3 4 function isAjax() { return (iss ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ75jVb.html" rel="bookmark" class="title">给PowerPooint演示文档添加声音</a>
					<div>
						我们想为演示文稿配上背景音乐,只要将音乐格式的文件插入到文稿中就行了: 执行&quot;插入→影片和声音→文件中的声音&quot;命令,打开&quot;插入声音&quot;对话框,选中需要插入的声音文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PeKjM.html" rel="bookmark" class="title">JS不间断向上滚动效果代码</a>
					<div>
						 不间断向上滚动的效果,想必大家都有见到过吧,本文也为大家准备一个使用js实现的不间断向上滚动效果,感兴趣的朋友可以参考下 代码如下: &lt;div id=demo style=overflow:h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYW8rb.html" rel="bookmark" class="title">word前几页不显示页码的图文教程</a>
					<div>
						  word,大家最常使用的办公软件,对于很多快捷键及常用功能都很熟悉,但是也难免遇到一些小问题,今天就有网友咨询:根据章节的需要,页码可能会有所要求,需要用到前几页封面不显示页码.这个毕业论文里很多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oPOAb.html" rel="bookmark" class="title">SystemTap了解</a>
					<div>
						SystemTrap是监控和跟踪运行中的Linux内核操作的动态方法. http://www.ibm.com/developerworks/cn/linux/l-systemtap/ 使用System ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwdE4M.html" rel="bookmark" class="title">v4l2-dev&lowbar;set&lowbar;name&comma; devcie&lowbar;register&comma; dev&lowbar;set&lowbar;drvdata&comma;</a>
					<div>
						问题描述 dev_set_name, devcie_register, dev_set_drvdata, 正在看一个V4L框架的camera驱动,有一段没搞明白意义: v4l2_i2c_subdev_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7wPrz.html" rel="bookmark" class="title">在mfc中使用CSplitterWnd分割窗口问题，想要拖动分隔条怎么使小窗口的大小和控件随着变化</a>
					<div>
						问题描述 在mfc中使用CSplitterWnd分割窗口问题,想要拖动分隔条怎么使小窗口的大小和控件随着变化 如上所述,我现在已经把一个界面分割成2行3列的6个小窗口,用来显示曲线图.但是,当我拖动分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr86OM.html" rel="bookmark" class="title">c语言问题-C语言的头文件有包含顺序吗？</a>
					<div>
						问题描述 C语言的头文件有包含顺序吗? C语言的头文件有包含顺序吗?有的话,是什么呀,---------- 解决方案 有包含顺序,即使添加了#ifndef也不一定有用 一个合理的建议:所有的.h中不包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBYQoM.html" rel="bookmark" class="title">spring-自动加载配置文件&bsol;使用属性文件注入</a>
					<div>
						在上一篇jsf环境搭建的基础上 , 加入spring框架 , 先看下目录结构 src/main/resources 这个source folder 放置web项目所需的主要配置,打包时,会自动打包到W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqWlQz.html" rel="bookmark" class="title">这个html窗口的后台用c&num;怎么写啊啊，用oracle数据库</a>
					<div>
						问题描述 这个html窗口的后台用c#怎么写啊啊,用oracle数据库 解决方案 下载安装oracle的驱动,代码和sql server差不多,参考:http://wenku.baidu.com/li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/M6ZwEJM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAxMTMxMzA3Mjc2ODY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Wm5WNWFXWmhibWM9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/M6ZwEJM.html" rel="bookmark" class="title">2014年博客之星评选，请大家多多支持</a>
					<div>
						我参加 了CSDN2014 博客之星大赛,请大家多多支持投我一票,谢谢. 参选理由:在技术的道路上,要学会学习和分享,不停追求,不停进步,直至完美.... 投票网址: http://vote.blog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBooaz.html" rel="bookmark" class="title">hamsterdb Embedded Storage 2&period;0&period;1发布 嵌入式数据库引擎</a>
					<div>
						hamsterdb Embedded Storage是一个采用ANSI-C语言编写的嵌入式数据库引擎.它具有可变长度的密钥和记录B+Trees.它支持内存中的数据库和尾数无关的文件,数据库游标,一个文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw8jEM.html" rel="bookmark" class="title">怎么把swing写的程序导出来生成可执行文件！（高手帮忙解决）</a>
					<div>
						问题描述 类似于把用swing写的俄罗斯方块导出来,生成一个类似于exe的文件,然后点击一下就可以玩游戏. 解决方案 解决方案二:不推荐生成所谓的exe文件,因为exe是windows下专用的应用程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw445M.html" rel="bookmark" class="title">漫谈&colon; 黑客，NSA 与自由软件</a>
					<div>
						Shawn the R0ck 写道 &quot;过去的20多年,FSF(自由软件基金会)和EFF(电子前哨基金会)一直是无政府主义(Anarchy)对抗BIG BROTHER的最前线,这种对抗不仅仅是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7BLqM.html" rel="bookmark" class="title">Movgrab 1&period;1&period;3发布 电影下载工具</a>
					<div>
						Movgrab是一个类似YouTube的网站命令行电影http://www.aliyun.com/zixun/aggregation/10481.html&quot;&gt;下载工具.它没有任何的依赖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWy2dz.html" rel="bookmark" class="title">Mysql 取字段值逗号第一个数据的查询语句&lowbar;Mysql</a>
					<div>
						复制代码 代码如下: select count(*) as lot from OA_sample_check where left(ecnNO, LOCATE(',',ecnNO)-1)='a1'					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYxn9b.html" rel="bookmark" class="title">20分钟轻松创建自己的Bootstrap站点&lowbar;javascript技巧</a>
					<div>
						本文的主要目的让你在20分钟内学会使用twitter bootstrap创建一个站点,如何建立站点,下文为大家介绍: 首先需要说的是twitter bootstrap是非常优秀的一个前端开源框架,它为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmYB1z.html" rel="bookmark" class="title">搜索引擎终极名单大全&excl;珍藏版本-搜索引擎技术</a>
					<div>
						搜索引擎研究ZoolinDingxiangDeyebAdmin5CreativeconfusionThreadwatchSeobookSeroundtableBattellemediaSearchen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1qQZb.html" rel="bookmark" class="title">为什么说Storm比Hadoop快？</a>
					<div>
						&quot;快&quot;这个词是不明确的,专业属于点有两个层面: 时延 , 指数据从产生到运算产生结果的时间,题主的&quot;快&quot;应该主要指这个. 吞吐, 指系统单位时间处理的数据量.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYPYAb.html" rel="bookmark" class="title">ffmpeg -vf中的命令参数-vf是什么意思</a>
					<div>
						问题描述 ffmpeg -vf中的命令参数-vf是什么意思 如题,ffmpeg -vf中的命令参数-vf是什么意思 .哪位朋友能指导一下,十分感谢 解决方案 -vf filter_graph set  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.046 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
